#include "tbsecp3-spi.h"

int Mute_EN = 0; 
int AutoMode = 0;
int Manual_EN = 0;
int Profile_EN = 0;
int Level_EN = 0;
int H_EN = 0;
int V_EN = 0;
int Bitrate_EN = 0;
int ImageChangeRate_EN = 0;
int Frame_EN = 0;
int Progname_EN = 0;
int Prognumber_EN = 0;
int Pid_EN = 0;
int Audio_Freq_EN = 0;

int Mute_Num = 0;
int Manual_Num = 0;
int Profile_Num = 0;
int Level_Num = 0;
int H_Num = 0;
int V_Num = 0;
float ImageChangeRate_Num = 1.25;
int Bitrate_Num = 0;
int Frame_Num = 0; 
u8 *Str_Progname = NULL;
u8 Program_Num = 0;
u32 PID[4] = {0};
u8 Audio_Freq_Num = 0;

char ipaddr[18] = {'\0'};
int ipport = 5442;
u8 Read_Streaming_EN = 0;
u8 Read_IP_Setting_EN = 0;

u8 *Streaming_file = NULL;
u8 *Network_file = NULL;

int hdex = 0;

u32 typeId = 0;
int udpfd = -1;
struct sockaddr_in udpsockaddr;

netinfor Net_Infor[64];//
int Net_Infor_numbor=0;

static const struct option long_options[] =
{
{ "get all the device",  no_argument, NULL, 'c' },
{ "local ip",  required_argument, NULL, 'i' },
{ "server port",  required_argument, NULL, 'p' },
{ "select capture",  required_argument, NULL, 'C' },
{ "get HDMI_inf",  no_argument, NULL, 'G' },
{ "load defaults",  no_argument, NULL, 'D' },
{ "mute",     required_argument,       NULL, 'm' },
{ "auto Mode to output format",  no_argument, NULL, 'A' },
{ "manual mode to output format ",  required_argument, NULL, 'M' },
{ "profile", 	     required_argument, NULL, 'p' },//1
{ "level", 	     required_argument, NULL, 'L' },//2
{ "H", 	     required_argument, NULL, 'H' },//3
{ "V", 	     required_argument, NULL, 'V' },//4
{ "bitrate", 	     required_argument, NULL, 'B' },//5
{ "frame", 	     required_argument, NULL, 'F' },//6
{ "set prog Name",     required_argument,       NULL, 'N' },
{ "set ProgramNumber",     required_argument,    NULL, 'n' },
{ "set PID",     required_argument,    NULL, 's' },
{ "set audio frequency select", required_argument, NULL, 'f' },
{ "read", no_argument, NULL, 'R' },
{ "read network Streaming", no_argument, NULL, 'T' },
{ "read network IP", no_argument, NULL, 't' },
{ "set network streaming", required_argument, NULL, 'U' },
{ "set network IP", required_argument, NULL, 'u' },
{ "refresh the status of the lamp ", no_argument, NULL, 'Z' },
{ "restart the device",     no_argument,    NULL, 'R' },
{ "reset the capture card",     no_argument,    NULL, 'r' },
{ "reset the channel",     no_argument,    NULL, 'd' },
{ "get the tool'version",     no_argument,    NULL, 'v' },
{ "help",            no_argument,       NULL, 'h' },
{ 0, 0, 0, 0 }
};

void usage()
{
    printf("\n");
    printf("Usage: TBSNetConfigurationTool:\n");
    printf("-i : local ip\n");
    printf("-p : server port\n");
    printf("-C : select the channel(0-15)\n");
    printf("-D : set the default of the channel\n");
    printf("-m : set output mute(1:mute,0:normal) when audio and video are out of sync\n");
    printf("\n");
    printf("set output format,one of the following three:\n");
    printf("Auto mode -A <Auto mode : Output resolution, code rate and frame rate will be identical to inputs>\n");
    printf("Manualmode -M <1--7, 1:Super 1920*1080, 2:Ultra 1440*1080, 3:Excellent 1280*720, 4:Good 1120*640, 5:Fair 960*540, 6:Poor 800*480, 7:Mobile 480*272>\n");
    printf("Advanced mode -P <H.264 Profile 0:high, 1:Main> -L <H.264 level:30/31/32/40/41/42> -H<size> -V<size>(1920*1080--480*272) -I <Max Bitrate/Ave Bitrate 1.20-3.00> -B <System BitRate 350--5000> -F <Encoding FrameRate 24--60>\n");
    printf("\n");
    printf("-N : set the program Name \n");
    printf("-n : set the Program Number\n");
    printf("-s : set the pid <pmt,prc,vpid,apid>\n");
    printf("-f : set the audio sampling rate <0: 48k,1: 44.1k,2: 32k,3: auto(only support hdmi)>\n");
    printf("-U : <config-file> set the network Streaming\n");
    printf("-u : <config-file> set the network IP\n");
    printf("-c : get all the devices\n");
    printf("-G : get the channel information(HDMI input and output formats) \n");
    printf("-T : get the information of network streaming\n");
    printf("-t : get the information of network ip\n");
    printf("-R : restart the device\n");
    printf("-r : reset the capture card(0-3)\n");
    printf("-d : reset the channel(0-15)\n");
    printf("-v : get the tool'version\n");
    printf("\n");
    exit(1);
}




int main( int i_argc, char **pp_argv )
{ 		 
    int c;
    int i=0;
    u8 tepdate[4] = {0};

	u8 Get_Card_EN = 0;
	u8 Cmm_IP_EN = 0, Cmm_Port_EN = 0, Cmm_Capture_EN = 0;
	u8 GET_HDMI_EN = 0;
	u8 Load_Defaults_EN = 0;
	u8 Set_Streamin_EN = 0 ,Set_Network_EN = 0;

	char *udp_ip = NULL;
	u16 udp_port = 0;
	u16 capture_X = 0;

	u8 Refresh_Status_EN = 0;

	u8 Version = 0; 

	u8 Restart_Device_EN = 0;

	u8 Reset_Channel_EN = 0;
	u8 Channel_Num = 0;

	u8 Reset_CaptureCard_EN = 0;
    u8 CaptureCard_Num = 0;

    if(i_argc == 1)
        usage();
    while ( (c = getopt_long(i_argc, pp_argv, "ci:p:C:GDm:AM:P:L:H:V:I:B:F:N:n:s:f:TtU:u:ZRr:d:vh", long_options, NULL)) != -1 )
    {
        switch ( c )
        {
        case 'c':
            Get_Card_EN = 1;
            break;
        case 'i':
			Cmm_IP_EN = 1;
            udp_ip = optarg;
            break;
        case 'p':
			Cmm_Port_EN = 1;
            udp_port = strtol( optarg, NULL, 0 );;
            break;
        case 'C':
			Cmm_Capture_EN = 1;
            capture_X = strtol( optarg, NULL, 0 );;
            break;
        case 'G':
            GET_HDMI_EN = 1;
            break;
        case 'D':
            Load_Defaults_EN = 1;
            break;
        case 'm':
            Mute_EN = 1;
            Mute_Num = strtol( optarg, NULL, 0 );
            break;
        case 'A':
            AutoMode=1;
            break;
        case 'M':
            Manual_EN = 1;
            Manual_Num=strtol( optarg, NULL, 0 );
            break;
        case 'P':
            Profile_EN = 1;
            Profile_Num=strtol( optarg, NULL, 0 );
            break;
        case 'L':
            Level_EN = 1;
            Level_Num=strtol( optarg, NULL, 0 );
            break;
        case 'H':
            H_EN = 1;
            H_Num=strtol( optarg, NULL, 0 );
            break;
        case 'V':
            V_EN = 1;
            V_Num=strtol( optarg, NULL, 0 );
            break;
        case 'I':
            ImageChangeRate_EN = 1;
            ImageChangeRate_Num=atof(optarg);
            break;
        case 'B':
            Bitrate_EN = 1;
            Bitrate_Num=strtol( optarg, NULL, 0 );
            break;
        case 'F':
            Frame_EN = 1;
            Frame_Num=strtol( optarg, NULL, 0 );
            break;
        case 'N':
            Progname_EN=1;
            Str_Progname = optarg;
            break;
        case 'n':
            Prognumber_EN = 1;
            Program_Num=strtol( optarg, NULL, 0 );
            break;
        case 's':
            Pid_EN = 1;
            sscanf(optarg,"%u,%u,%u,%u",&PID[0],&PID[1],&PID[2],&PID[3]);
            break;
        case 'f':
            Audio_Freq_EN = 1;
            Audio_Freq_Num = strtol( optarg, NULL, 0 );
            break;
        case 'T':
            Read_Streaming_EN = 1;
            break;
        case 't':
            Read_IP_Setting_EN = 1;
            break;
        case 'U':
            Set_Streamin_EN = 1;
            Streaming_file = optarg;
            break;
        case 'u':
            Set_Network_EN = 1;
            Network_file = optarg;
            break;
        case 'Z':
			Refresh_Status_EN = 1;
            break;
        case 'R':
			Restart_Device_EN = 1;
            break;
        case 'r':
			Reset_CaptureCard_EN = 1;
            CaptureCard_Num = strtol( optarg, NULL, 0 );
            break;
        case 'd':
			Reset_Channel_EN = 1;
            Channel_Num = strtol( optarg, NULL, 0 );
            break;
        case 'v':
            Version = 1;
			break;
        case 'h':
            usage();
            break;
        default:
            usage();
        }
    }

    if(optind < i_argc )
        usage();
    if(Version == 1)
	{
        printf("The tool'version is V1.0.0.0.1\n");
        return 0;
    }
	/* 获取子卡，主卡（刷新） */
	if(Get_Card_EN == 1)
	{
    	udpMulticastClinet();
		printf_card_inf();
		return 0;
	}
	if(1 == Cmm_IP_EN && 1 == Cmm_Port_EN)
	{
		/*restart*/
    	if(1 == Restart_Device_EN)
		{    
			restartDevice(udp_ip,udp_port);
    	}
    	else if(1 == Reset_CaptureCard_EN)
		{    
			resetCaptureCard(udp_ip,udp_port,CaptureCard_Num);
    	}
    	else if(1 == Reset_Channel_EN)
		{    
			resetChannel(udp_ip,udp_port,Channel_Num);
		}
		else if(1 == Cmm_Capture_EN)
		{	
    		if(1 == GET_HDMI_EN)/* GET HDMI */
			{    
				selectIp(udp_ip,udp_port,capture_X);
				monopolizeCpu_close();
				monopolizeCpu_open();
				readBuffer();//
				monopolizeCpu_close();
    		}
    		else if(Mute_EN == 1 || (AutoMode == 1 || Manual_EN == 1 || \
				(Profile_EN == 1 && Level_EN == 1 && H_EN == 1 && V_EN == 1 && ImageChangeRate_EN == 1 && Bitrate_EN == 1 && Frame_EN == 1)) || \
				Progname_EN == 1 || Prognumber_EN == 1 || Pid_EN == 1 || Audio_Freq_EN == 1)/* SET HDMI */
			{    
				selectIp(udp_ip,udp_port,capture_X);
				monopolizeCpu_close();
				monopolizeCpu_open();
				writeBuffer();//
				monopolizeCpu_close();
    		}
			else if(1 == Load_Defaults_EN)/* 恢复默认值 */
			{	
				selectIp(udp_ip,udp_port,capture_X);
				monopolizeCpu_close();
				monopolizeCpu_open();	
				LoadDefaults();//
				monopolizeCpu_close();
			}
		}
		else if(1 == Read_Streaming_EN || 1 == Read_IP_Setting_EN)/* Read Streraming or IP_Setting */
		{
			Network_read(udp_ip,udp_port);//
		}
		else if(Set_Streamin_EN == 1 && Streaming_file != NULL)/* Network Streaming */
		{
			setStreamingArg(udp_ip,udp_port);//
		}
		else if(1 == Set_Network_EN)
		{
 			setLocal_IP_Port(udp_ip,udp_port);//
		}
		else if(1 == Refresh_Status_EN)/*refresh status*/
		{
			refresh_status(udp_ip,udp_port);
		}
		else
		{
    	    usage();
		}
	}
	else
	{
    	usage();
	}
    if((Get_Card_EN == 0) && (Cmm_IP_EN == 0) && (Cmm_Port_EN == 0) && (Cmm_Capture_EN == 0)\
            && (GET_HDMI_EN == 0) && (Load_Defaults_EN == 0) && (Mute_EN == 0) && (AutoMode == 0) 
			&& (Manual_EN == 0) && (Profile_EN == 0) && (Level_EN == 0) && (H_EN == 0) && (V_EN == 0)\
			&& (ImageChangeRate_EN == 0) && (Bitrate_EN == 0) && (Frame_EN == 0) && (Progname_EN == 0)\
			&&(Prognumber_EN == 0)&&(Pid_EN == 0) && (Audio_Freq_EN == 0) && (Read_Streaming_EN == 0)\
			&& (Read_IP_Setting_EN == 0) && (Set_Streamin_EN == 0) && (Set_Network_EN == 0)\
			&& (Refresh_Status_EN == 0) && (Restart_Device_EN == 0)\
			&& (Reset_Channel_EN == 0) && (Reset_CaptureCard_EN == 0) && (Version == 0)
		)
        usage();
    udpClose(udpfd);
    return 0;
}   
