#include <stdlib.h>
#include <stdio.h>
#include <stdint.h>
#include <inttypes.h>
#include <string.h>
#include <errno.h>
#include "tbsecp3-spi.h"

extern int Mute_EN; 
extern int AutoMode;
extern int Manual_EN;
extern int Profile_EN;
extern int Level_EN;
extern int H_EN;
extern int V_EN;
extern int ImageChangeRate_EN;
extern int Bitrate_EN;
extern int Frame_EN;
extern int Progname_EN;
extern int Prognumber_EN;
extern int Pid_EN;
extern int Audio_Freq_EN;

extern int Mute_Num;
extern int Manual_Num;
extern int Profile_Num;
extern int Level_Num;
extern int H_Num;
extern int V_Num;
extern float ImageChangeRate_Num;
extern int Bitrate_Num;
extern int Frame_Num;
extern u8* Str_Progname;
extern u8 Program_Num;
extern u32 PID[4];
extern u8 Audio_Freq_Num;


extern char ipaddr[18];
extern int ipport;
extern u8 Read_Streaming_EN;
extern u8 Read_IP_Setting_EN;

extern u8 *Streaming_file;
extern u8 *Network_file;

extern u8 open_or_close;

extern int Net_Infor_numbor;
extern netinfor Net_Infor[64];

u8 device = 0;

void write_M23Register( int num, int* m23_addr, int* m23_data)
{
    unsigned char tmpM23addr[4];
    unsigned char tmpM23data[4];
    int i =0;
    for(i=0;i<num;i++)
    {
        tmpM23addr[0]= (*(m23_addr+i) & 0xff00) >>8;
        tmpM23addr[1]=	*(m23_addr+i) & 0xff;
        tmpM23addr[2]= 0;
        tmpM23addr[3]= 0;
        tmpM23data[0]= (*(m23_data+i) & 0xff00) >>8;
        tmpM23data[1]= *(m23_data+i) & 0xff;
        tmpM23data[2]= 0;
        tmpM23data[3]= 0;
        target_ext_memory_rd_wt(WRITE,0x80*(hdex%4)+0x20+i*4,tmpM23addr,2);
        target_ext_memory_rd_wt(WRITE,0x80*(hdex%4)+0x22+i*4,tmpM23data,2);
    }
    return;
}

void read_M23Register( int num, int* m23_data)
{
    unsigned char tmpM23data[4];
    int i =0;

    for(i=0;i<num;i++)
    {
        target_ext_memory_rd_wt(READ,0x80*(hdex%4)+0x22+i*4,tmpM23data,2);
        *(m23_data+i) = tmpM23data[1]&0xff;
        *(m23_data+i) += ((tmpM23data[0]<<8)&0xff00);
    }
    return;
}

void udp_REG64_rd_child(int subAddr, unsigned char num, unsigned char * rdbuffer)
{
    unsigned char i,j, tmp[8];
    if (num == 0)
    {
        //printf(" rd error! (num == 0)");
        return;
    }
    else if (num > 4)
    {
        //printf(" rd error! (num >4) ");
        return;

    }
    tmp[0] = 0x80;//read; bit7 = 1;
    tmp[1] = 0; //don't care;
    tmp[2] = (unsigned char)((subAddr >> 8) & 0xff);	 //address high;
    tmp[3] = (unsigned char)(subAddr & 0xff); 		 //address low;
    udp_REG64_wt(NET_100M_ADDR((hdex/4)) + NET100M_CMD, 4, tmp);
    // ack done;
    i = 0;
    do {
        udp_REG64_rd(NET_100M_ADDR((hdex / 4)) + NET100M_ACK, 4, tmp);
        usleep(2000);
        i++;
    } while ((i < 100) && (tmp[0] == 255));
    if (i == 100)
    {
       // printf("[udp_REG64_rd_child] check udp_cmd done timeout, Exit!\n");
        return;
    }
    udp_REG64_rd(NET_100M_ADDR((hdex / 4)) + NET100M_RDDT, num, rdbuffer);
  //  for (j = 0; j < 4; j++) {
        //printf("r:%d\n", rdbuffer[j]);
   // }
    return;
}

void udp_REG64_wt_child(int subAddr, unsigned char num, unsigned char * wtbuffer)
{
    unsigned char i, tmp[8];
    int  j = 0;
    if (num == 0)
    {
        printf(" wt error! (num == 0)  ");
        return;
    }
    else if (num > 4)
    {
        printf(" wt error! (num >4) ");
        return;

    }
    for ( j = 0; j < 4; j++) {
        //qDebug("w:%d", buff[j]);
    }
    udp_REG64_wt(NET_100M_ADDR((hdex / 4)) + NET100M_DT32, num, wtbuffer);
    tmp[0] = 0; //write; bit7 = 0;
    tmp[1] = 0; //don't care;
    tmp[2] = (unsigned char)((subAddr >> 8) & 0xff);	 //address high;
    tmp[3] = (unsigned char)(subAddr & 0xff); 		 //address low;
    udp_REG64_wt(NET_100M_ADDR((hdex / 4)) + NET100M_CMD, 4, tmp);
    // ack done;
    i = 0;
    do {
        udp_REG64_rd(NET_100M_ADDR((hdex / 4)) + NET100M_ACK, 4, tmp);
        usleep(2000);
        i++;
    } while ((i < 100) && (tmp[0] == 255));
    if (i == 100)
    {
       // printf("[udp_REG64_wt_child] check udp_cmd done timeout, Exit!");
        return;
    }
    return;
}

void REG64_rd(int subAddr, unsigned char num, unsigned char * rdbuffer)
{
    switch (typeId) {
    case 6316:
        udp_REG64_rd(subAddr, num, rdbuffer);
        break;
    case 63081:
        udp_REG64_rd_child(subAddr, num, rdbuffer);
        break;
    default:
        break;
    }
    return;
}
void REG64_wt(int subAddr, unsigned char num, unsigned char * wtbuffer)
{
    switch (typeId) {
    case 6316:
        udp_REG64_wt(subAddr, num, wtbuffer);
        break;
    case 63081:
        udp_REG64_wt_child(subAddr, num, wtbuffer);
        break;
    default:
        break;
    }
    return;
}

bool ext_one_time_wt(int m_addr, unsigned char *wtbuff, unsigned char num) {
    switch (typeId) {
    case 63081:
    case 6316:
        return ext_one_time_wt_REG32(m_addr, wtbuff, num);
        break;
    default:
        break;
    }
    return 0;
}

bool ext_one_time_rd(int m_addr, unsigned char *rdbuff, unsigned char num) {
    switch (typeId) {
    case 63081:
    case 6316:
        return ext_one_time_rd_REG32(m_addr, rdbuff, num);
        break;
    default:
        break;
    }
    return 0;
}

bool Check_host_status(unsigned char cs)
{
    unsigned char j, tmp[4];
    int i;
    int count = 0;
	bool ret = 0;

    j = 1;
    for (i = 0; ((i < 4000) && j); i++)
    {
        REG64_rd(0x4000 + 0 * 4, 4, tmp);
        if ((tmp[0] & 1) != cs)
        {
            j = 1;
			ret = 0;
            usleep(500); //delay 500uS;
                      //        count++;
        }
        else
		{
			ret = 1;
            j = 0;
		}
    }
    //   qDebug("ctime: %d us\n", count*500);
    //return (j != 4000);
	return ret;
}

bool wait_for_host_workdone()  //3 seconds timeout;
{
    unsigned char j, tmp[4];
    int i;
    int count = 0;
	bool ret = 0;
    j = 0;
    for (i = 0; ((i < 600) && (j == 0)); i++)
    {
        REG64_rd(0x4000 + 0 * 4, 4, tmp);
        j = (tmp[0] & 1);
        if (j == 0) {
            usleep(5000);  //delay 5mS
                       //   count ++;
			ret = 0;
        }
		else {
			ret = 1;
		}
    }
    //    qDebug("wtime: %d ms\n", count*5);
    //return (j != 600);
	return ret;
}

//===............................................................................

bool ext_one_time_wt_REG32(int m_addr, unsigned char *wtbuff,unsigned char num)
{
    unsigned char i, buff[8];

    if (num == 0)
    {
        //qDebug(" wt error! (num == 0) ");
        return false;

    }
    else if (num > 8)
    {
       // qDebug(" wt error! (num >8) ");
        return false;

    }
    //...check host free -->......................
    if (Check_host_status(1) == 0)
    {
       // qDebug(" wait for host free timeout! ");
        return false;
    }

    //...wt data & cs to low-->...................
    for (i = 0; i < num; i++)
        buff[i] = wtbuff[i];
    REG64_wt(0x4000 + 2 * 4, 4, &buff[4]);
    REG64_wt(0x4000 + 1 * 4, 4, &buff[0]);

    buff[0] = 0x30;
    buff[1] = num;
    buff[2] = (unsigned char)(m_addr >> 8);
    buff[3] = (unsigned char)(m_addr & 255);
    REG64_wt(0x4000 + 0 * 4, 4, buff); //cs low;
    usleep(1000);
    //...ck host received data & process-->........
    if (Check_host_status(0) == 0)
    {
        //qDebug(" wait for host active timeout!");
        REG64_wt(0x4000 + 3 * 4, 4, buff); //cs high;
        return false;
    }

    //...cs high................................
    REG64_wt(0x4000 + 3 * 4, 4, buff); //cs high;
    //...check host work done-->..................
    if (wait_for_host_workdone() == 0)
    {
       // qDebug(" wait host work done timeout!");
        return false;
    }
    return true;
}

//===............................................................................

bool ext_ram_write(int ram_addr, unsigned char *wtbff, int wt_size)
{
    int i,k,x8byte;
    unsigned char finishbyte;

    x8byte = wt_size/8;
    finishbyte = (unsigned char)(wt_size & 7);

    //first send & remainder bytes.
    if(finishbyte == 0)
    {
        finishbyte = 8;
        x8byte -=1;
    }
    ext_one_time_wt(ram_addr,wtbff,finishbyte);

    i = finishbyte;
    if(x8byte!=0)
    {
        for(k=0;k<x8byte;k++)
            ext_one_time_wt((ram_addr+i+k*8),&wtbff[i+k*8],8);
    }

    return 0;
}

//===............................................................................

bool ext_one_time_rd_REG32(int m_addr, unsigned char *rdbuff,unsigned char num)
{
    unsigned char i, buff[8];

    if (num == 0)
    {
        //printf(" rd error! (num == 0)\n");
        return false;

    }
    else if (num > 8)
    {
        //printf(" rd error! (num >8) \n");
        return false;

    }
    //...check host free -->......................
    if (Check_host_status(1) == 0)
    {
        //printf(" wait for host free timeout!\n");
        return false;
    }
    //...wt data & cs to low-->...................
    buff[0] = 0x31;
    buff[1] = num;
    buff[2] = (unsigned char)(m_addr >> 8);
    buff[3] = (unsigned char)(m_addr & 255);
    REG64_wt(0x4000 + 0 * 4, 4, buff);	  //cs low;
    usleep(1000);
    //...ck host received data & process-->........
    if (Check_host_status(0) == 0)
    {
        // qDebug(" wait for host active timeout! ");
        REG64_wt(0x4000 + 3 * 4, 4, buff);	  //cs high;
        return false;
    }
    //...cs high................................
    REG64_wt(0x4000 + 3 * 4, 4, buff);	  //cs high;
    //...check host work done-->..................
    if (wait_for_host_workdone() == 0)
    {
        // qDebug(" wait host work done timeout!");
        return false;
    }
    REG64_rd(0x4000 + 1 * 4, 4, &buff[0]);
    REG64_rd(0x4000 + 2 * 4, 4, &buff[4]);
    for (i = 0; i < num; i++)
        rdbuff[i] = buff[i];
    return true;
}

//===............................................................................

bool ext_ram_read(int ram_addr, unsigned char *rdbff, int rd_size)
{
    int i, k,x8byte;
    unsigned char finishbyte, buff[8];
    // printf("ram_addr:%#x\n",ram_addr);
    x8byte = rd_size/8;
    finishbyte = (unsigned char)(rd_size & 7);

    //first send & remainder bytes.
    if(finishbyte == 0)
    {
        finishbyte = 8;
        x8byte -=1;
    }
    ext_one_time_rd(ram_addr,rdbff,finishbyte);

    i = finishbyte;
    if(x8byte!=0)
    {
        for(k=0;k<x8byte;k++)
            ext_one_time_rd((ram_addr+i+k*8),&rdbff[i+k*8],8);
    }

    return 0;
}

bool target_ext_memory_rd_wt(unsigned char tg_mode,int  tg_addr,unsigned char *buff,int tg_size)
{
    // printf("tg_addr:%#x = %#x\n",tg_addr,*tg_addr);
    if(tg_mode == READ)
        ext_ram_read(tg_addr,buff,tg_size);
    else if(tg_mode == WRITE)
        ext_ram_write(tg_addr,buff,tg_size);
    else
        printf("[target_external_memory_rd_wt] read write mode error! \n");
    return 0;
}

int udp_checkI2cBusStatus()
{
    u8 tmpbuf[8] = {0};
    int i = 0;
    udp_REG64_wt(0xfff5,8,tmpbuf);
    memset(tmpbuf,0,8);
    udp_REG64_rd(0xfff5,8,tmpbuf);
    for (i = 0; i < 8; i++) {
        if (0x80 != (u8)tmpbuf[i]) {
            printf("udp check i2c bus status is busy !!!\n");
            return -1;
        }
    }
    return 0;
}

void udp_REG64_rd(int subAddr, unsigned char num, unsigned char * rdbuffer)
{


    char sendbuff[64] = { 0 };
    char recvbuff[64] = { 0 };
    socklen_t len = sizeof(udpsockaddr);
    int n = 0;
    int i = 0;
    int j = 0;
    // 27bit address
    sendbuff[0] = 0xc0+ (u8)((subAddr & 0x07000000) >> 24);
    sendbuff[1] = (u8)((subAddr & 0x00ff0000) >> 16);
    sendbuff[2] = (u8)((subAddr & 0x0000ff00) >> 8);
    sendbuff[3] = (u8)((subAddr & 0x000000ff));

    //sendbuff[2] = 0x80;
    //sendbuff[3] = 0x20;
    n = sendto(udpfd, sendbuff, 64, 0, (struct sockaddr*)&udpsockaddr, len);

    if (n < 0) {
        printf("udp_REG64_rd:sendto time out\n");
        return ;
    }
    n = recvfrom(udpfd, recvbuff, 64, 0, (struct sockaddr*)&udpsockaddr, &len);

    if (n < 0) {
        printf("udp_REG64_rd:recvfrom3 time out\n");
        return ;
    }
    for ( i = 0; i < 12; i++) {
        //	qDebug("udp_REG64_rd recv:%d=%02x", i, (u8)recvbuff[i]);
        if ((i > 3) &&(j < num)) {
            rdbuffer[j] = (u8)recvbuff[i];
            j++;
        }
    }
    return;
}

void udp_REG64_wt(int subAddr, unsigned char num, unsigned char * wtbuffer)
{
    char sendbuff[64] = { 0 };
    char recvbuff[64] = { 0 };
    socklen_t len  = sizeof(udpsockaddr);
    int n = 0;
    int i = 0;
    int j = 0;

    // 27bit address
    sendbuff[0] = 0x00 + (u8)((subAddr & 0x07000000) >> 24);
    sendbuff[1] = (u8)((subAddr & 0x00ff0000) >> 16);
    sendbuff[2] = (u8)((subAddr & 0x0000ff00) >> 8);
    sendbuff[3] = (u8)((subAddr & 0x000000ff));

    for (i = 0; i < num;i++) {
        sendbuff[i+4] = wtbuffer[i];
    }
    n = sendto(udpfd, sendbuff, 64, 0, (struct sockaddr*)&udpsockaddr, len);
    if (n < 0) {
        printf("udp_REG64_wt:sendto time out\n");
        return ;
    }

    memset(recvbuff, 0, 64);
    n = recvfrom(udpfd, recvbuff, 64, 0, (struct sockaddr*)&udpsockaddr, &len);
    if (n < 0) {
        printf("udp_REG64_wt:recvfrom time out\n");
        return ;
    }
    for ( i = 0; i < 12; i++) {
        //qDebug("udp_REG64_wt:recv:%d=%02x", i, (u8)recvbuff[i]);
    }
    return ;
}


//net
int udpOpen(char * ipaddr,int ipport)
{

    int n = 0;
    int i = 0;
    int j = 0;
    int ufd = -1;
    char sendbuff[64] = {0};
    char recvbuff[64] = {0};
    struct timeval timeout = {1,0};
    u8 tmpbuf[8] = { 0x80, 0x80, 0x80, 0x80, 0x80, 0x80, 0x80, 0x80 };

    /*create Socket*/
    if ((ufd = socket(AF_INET, SOCK_DGRAM, 0)) == -1) {
        printf( "fail to socket\n");
        return 0;
    }
    /*set sockaddr_in*/
    memset(&udpsockaddr, 0, sizeof(udpsockaddr));
    udpsockaddr.sin_family = AF_INET;
    udpsockaddr.sin_port = htons(ipport);
    udpsockaddr.sin_addr.s_addr = inet_addr(ipaddr);
    socklen_t len  = sizeof(udpsockaddr);
    setsockopt(ufd, SOL_SOCKET, SO_RCVTIMEO, (char *)&timeout, sizeof(struct timeval));
    setsockopt(ufd, SOL_SOCKET, SO_SNDTIMEO, (char *)&timeout, sizeof(struct timeval));
    return ufd;
}
int udpClose(int ufd)
{
    int n = 0;
    char sendbuff[64] = { 0 };
    char recvbuff[64] = { 0 };
    socklen_t len  = sizeof(udpsockaddr);
    if (ufd > 2) {
        close(ufd);
        return 0;
    }
    return ufd;
}
/* 刷新获取主卡，子卡 */
int getswitchstatus(u8* ip, u16 port,netinfor* Net_Infor)
{
    u8 tmpid[4] = { 0 };
	u8 status = 0x0f;
	int i = 0;
	int j = 0;

	udpfd = udpOpen(ip,port);

	udp_REG64_rd(0x4000+20, 1, &status);
	//printf("status:%#x\n\n",status);
	for (i = 0; i < 4; i++) 
	{
		if (0 == ((status >> i) & 0x01)) //开
		{
			for (j = 0; j < 4; j++) 
			{
				Net_Infor->Item_tuner[i * 4 + j] = i * 4 + j; 
			}
		}
		else //关
		{
			for (j = 0; j < 4; j++) 
			{
				Net_Infor->Item_tuner[i * 4 + j] = -1;
			}
		}
	}
		
	udpClose(udpfd);
	udpfd = 0;
	typeId = 0;
	return 0;
}
int get_1000M_or_100M(u8* ip, u16 port)
{
	u8 M[8] = { 0 };
	int i = 0;
	int j = 0;
	udpfd = udpOpen(ip, port);
	memset(M, 0, 8);
	udp_REG64_rd(0x4000 + 24, 1, M);
	udpClose(udpfd);
	udpfd = 0;
	typeId = 0;
	return (M[0] & 0x01);
}
void showNetTuners(char *ipport_mac)
{
	int i=0,j=0;
	u8* ipport = strtok(ipport_mac, "/");
	u8* mac = strtok(NULL, "/");//mac

	u8* name = strtok(ipport, ":");//name
	u8* ip = strtok(NULL, ":");//ip
	u16 port = atoi(strtok(NULL, ":"));//port
    u8 net_flg = get_1000M_or_100M(ip,port);//判断ip net_flg=0(100M) net_flg=1(1000M)
	//printf("100M&1G=%d %s:%s:%d  %s\n\n",net_flg,name,ip,port,mac);

	if(device > 0)
	{
		for(j=0;j<device;j++)
		{
			if(strcmp(mac,Net_Infor[j].mac) == 0)
			{

				if(net_flg == 0)//100M
				{
					Net_Infor[j].port_100M = port;
					strcpy(Net_Infor[j].ip_100M,ip);
				}
				else if(net_flg == 1)//1000M
				{
					Net_Infor[j].port_1000M = port;
					strcpy(Net_Infor[j].ip_1000M,ip);
				}
				return;
			}
		}
	}

	strcpy(Net_Infor[device].name,name);
	strcpy(Net_Infor[device].mac,mac);		
	if(net_flg == 0)//100M
	{
		Net_Infor[device].port_100M = port;
		strcpy(Net_Infor[device].ip_100M,ip);

		Net_Infor[device].port_1000M = 0;
		memset(Net_Infor[device].ip_1000M,0,sizeof(Net_Infor[device].ip_1000M));
	}
	else if(net_flg == 1)//1000M
	{
		Net_Infor[device].port_100M = 0;
		memset(Net_Infor[device].ip_100M,0,sizeof(Net_Infor[device].ip_100M));

		Net_Infor[device].port_1000M = port;
		strcpy(Net_Infor[device].ip_1000M,ip);
	}

	getswitchstatus(ip,port,&Net_Infor[device]);//获取拨马开关状态

	Net_Infor[device].validCaptureNum = 0;
	for (i = 0; i < 16; i++) 
	{
		if (-1 != Net_Infor[device].Item_tuner[i]) 
		{
			Net_Infor[device].validCaptureNum++;
		}

	}

	Net_Infor_numbor = device;
	device++;
	return;
}


void printf_card_inf()
{
	int i,j;
	for(i = 0; i <= Net_Infor_numbor; i++)
	{
		//printf("%s\n", Net_Infor[i].ip_100M);
		if((strlen(Net_Infor[i].ip_100M) == 0) && (Net_Infor[i].port_100M == 0))
			printf("ip_port: TBS8030:%s:%d %d\n",Net_Infor[i].ip_1000M,Net_Infor[i].port_1000M,Net_Infor[i].validCaptureNum);
		else if((strlen(Net_Infor[i].ip_1000M) == 0) && (Net_Infor[i].port_1000M == 0))
			printf("ip_port: TBS8030:%s:%d %d\n",Net_Infor[i].ip_100M,Net_Infor[i].port_100M,Net_Infor[i].validCaptureNum);
		else
			printf("ip_port: TBS8030:%s:%d/%s:%d %d\n", Net_Infor[i].ip_1000M,Net_Infor[i].port_1000M,Net_Infor[i].ip_100M,Net_Infor[i].port_100M,Net_Infor[i].validCaptureNum);
		if(Net_Infor[i].validCaptureNum != 0)
		{
			for (j = 0; j < 16; j++) 
			{
				if(Net_Infor[i].Item_tuner[j] == -1)
					continue;
				else
					printf("capture %d\n", Net_Infor[i].Item_tuner[j]);
			}
		}
	}
}
void udpMulticastClinet()
{
	struct sockaddr_in addr;
	int Mfd;
	char recvtmp[64] = {'\0'};
	char sendbuf[64] = {'\0'};
	char recvbuf[64] = {'\0'};
	u8 tmp[2] = {0};
	if ((Mfd=socket(AF_INET,SOCK_DGRAM,0)) < 0)
	{
		printf("fail to socket\n");
		return;
	}
	memset(&addr,0,sizeof(addr));
	addr.sin_family=AF_INET;
	addr.sin_addr.s_addr=inet_addr("239.255.0.9");//发送组播
	addr.sin_port=htons(21571);//0x5443
	//struct timeval timeout = {0,500000};//{s,us}
	struct timeval timeout = {1,0};//{s,us}
	setsockopt(Mfd, SOL_SOCKET, SO_RCVTIMEO, (char *)&timeout, sizeof(struct timeval));
	setsockopt(Mfd, SOL_SOCKET, SO_SNDTIMEO, (char *)&timeout, sizeof(struct timeval));
	socklen_t len = sizeof(addr);
	sendbuf[0] = 0xc0;//read
	sendbuf[1] = 0xff;
	sendbuf[2] = 0xff;
	sendbuf[3] = 0xff;
	sendbuf[4] = 0x54;
	sendbuf[5] = 0x42;
	sendbuf[6] = 0x53;
	sendbuf[7] = 0x50;
	sendbuf[8] = 0x52;
	sendbuf[9] = 0x4f;
	sendbuf[10] = 0x44;
	sendbuf[11] = 0x54;
	if (sendto(Mfd,sendbuf, strlen(sendbuf), 0, (struct sockaddr *) &addr, len) < 0)
	{
		printf("fail to sendto\n");
		//exit(1);
		return;
	}

	int i = 0;
	int j = 0;
	int k = 0;
	while(i<16)
	{
		int n = recvfrom(Mfd,recvbuf, 64, 0, (struct sockaddr *)&addr,&len );
		if (n < 0) 
		{
			//printf("scan ip dev over\n");
			break;
		}
		else
		{
			if ((((u8)(0x80) != (u8)recvbuf[4]) &&
				((u8)(0x63) != (u8)recvbuf[4])) ||
				(((u8)(0x30) != (u8)recvbuf[5]) &&
				((u8)(0x16) != (u8)recvbuf[5])) ||
				(((u8)(0x00) != (u8)(recvbuf[12])) ||
				((u8)(0x22) != (u8)(recvbuf[13])) ||
				((u8)(0xab) != (u8)(recvbuf[14])))) {
				continue;
			}
			tmp[0] = (u8)recvbuf[11];
			tmp[1] = (u8)recvbuf[10];
			sprintf(recvtmp, "TBS%02x%02x:%d.%d.%d.%d:%d"
				"/%02x:%02x:%02x:%02x:%02x:%02x",
				(u8)0x80, (u8)0x30, (u8)recvbuf[6], \
				(u8)recvbuf[7], (u8)recvbuf[8],
				(u8)recvbuf[9], *(u16*)&tmp[0],
				(u8)recvbuf[12], (u8)recvbuf[13],
				(u8)recvbuf[14], (u8)recvbuf[15],
				(u8)recvbuf[16], (u8)recvbuf[17]);
            //printf("%d) %s\n",i,recvtmp);
			showNetTuners(recvtmp);
			i++;
		}
			memset(recvbuf,0,sizeof(recvbuf));
	}
	close(Mfd);
	return;
}


/*  Select IP to communicate with FPJA  */
void selectIp(char* udp_ip, u16 udp_port, u16 capture_X)
{
    //char ipaddr[18] = {'\0'};
    //int ipport = 5442;
	if(udp_ip == NULL)
	{
		printf("Please enter the IP of FPJA\n");
		exit(1);	
	}
	else
	{
        sprintf(ipaddr,"%s",udp_ip);
        ipport = udp_port;
        udpfd = udpOpen(ipaddr,ipport);
        typeId = 63081;
    	hdex = capture_X;
    }
}


/* 设置HDMI后执行该函数让设置生效 */
int reHdmi()
{
	u8 tmpbuf[4] = { 0 };
	target_ext_memory_rd_wt(WRITE, ADDRESS_HDMI(hdex%4) + 0x08, tmpbuf, 1);
	return 0;
}
/*...............  readBuffer  ..................*/
void writeBuffer()
{
	if(Mute_EN == 1)
    {
        setMute();
    }
    if(AutoMode == 1)
    {
		autoMode();
    }
    else if(Manual_EN == 1)
    {
		manualMoe();
    }
    else if((Profile_EN == 1)&&(Level_EN == 1)&&(H_EN == 1)&&(V_EN == 1)&& 
			(ImageChangeRate_EN == 1) &&(Bitrate_EN == 1)&&(Frame_EN == 1))
    {
		advancedMode();
    }

    if(Progname_EN == 1)
    {
        setprogname(Str_Progname);
    }

    if(Prognumber_EN == 1)
	{
		setProgramNo();
    }

    if(Pid_EN == 1)
	{
		setPid();
    }
    if(Audio_Freq_EN == 1)
	{
		setAudioSourceAndFreq();
    }



	reHdmi();//设置HDMI后执行该函数让设置生效
	readBuffer();
	return;
}

/* set MUTE */
void setMute()
{
    unsigned char temdate[4] = {0};
    temdate[0] = Mute_Num;
    target_ext_memory_rd_wt(WRITE,0x80*(hdex%4)+0x16,temdate,1);
	return;
}


/* set outputfmt */
void autoMode()
{
    unsigned char tepdate[4]={0};
    //printf("set output format to auto mode(the same with input format)\n");
    //set to 24cxx 0x14 to 1
    tepdate[0] = 1;
    target_ext_memory_rd_wt(WRITE,0x80*(hdex%4)+0x14,tepdate,1);
    tepdate[0] = 0;
    target_ext_memory_rd_wt(WRITE,0x80*(hdex%4)+0x15,tepdate,1);
	return;
}
void manualMoe()
{
    unsigned char tepdate[4]={0};
    //printf("set output format to manual mode:\n");
    //set to 24cxx 0x14 to 0 and 0x15 to num
    tepdate[0] = 0;
    target_ext_memory_rd_wt(WRITE,0x80*(hdex%4)+0x14,tepdate,1);
    tepdate[0] = Manual_Num;
    target_ext_memory_rd_wt(WRITE,0x80*(hdex%4)+0x15,tepdate,1);
	return;
}
void advancedMode()
{
	u8 tepdate[4] = { 0 };

    //set to 24cxx 0x14 to 0 and 0x15 to 0
    tepdate[0] = 0;
    target_ext_memory_rd_wt(WRITE,0x80*(hdex%4)+0x14,tepdate,1);
    target_ext_memory_rd_wt(WRITE,0x80*(hdex%4)+0x15,tepdate,1);
    //printf("set output format to advanced: %d,%d,%d,%d,%d,%d\n",Profile_Num,Level_Num,H_Num,V_Num,Bitrate_Num,Frame_Num);

    int outsettingAddress[11];
    int outsettingFormat[11];


    outsettingAddress[0]= 0x1526; // profileLevel
    outsettingAddress[1]= 0x152c; // H
    outsettingAddress[2]= 0x152e; // V
    outsettingAddress[3]= 0x1532; // biteRate
    outsettingAddress[4]= 0x1534;
    outsettingAddress[5]= 0x1536;
    outsettingAddress[6]= 0x1538;
    outsettingAddress[7]= 0x1104;
    outsettingAddress[8]= 0x1584; // framRate
    outsettingAddress[9]= 0x1586;
    outsettingAddress[10]= 0x1588;

    if(Profile_Num == 1)
        Level_Num += 512; // Main profile
    else
        Level_Num += 256; // high profile

    //write data
    outsettingFormat[0] = Level_Num;
    outsettingFormat[1] = H_Num;
    outsettingFormat[2] = V_Num;

    /*outsettingFormat[3] = Bitrate_Num *2.5;
    outsettingFormat[4] = Bitrate_Num *2;
    outsettingFormat[5] = Bitrate_Num ;
    outsettingFormat[6] = Bitrate_Num *0.5;
    outsettingFormat[7] = Bitrate_Num *3.5;*/
    outsettingFormat[3] = Bitrate_Num - 200;
    outsettingFormat[4] = Bitrate_Num - 300;
    outsettingFormat[5] = (Bitrate_Num - 300) / ImageChangeRate_Num;

	int AVE_bit = outsettingFormat[5];
	float tmp = (float)(AVE_bit * 1000 / 1024) / 1000;
	if(tmp < 5)
		outsettingFormat[6] = AVE_bit * 0.5;
	else if(tmp >= 5 && tmp <= 10)
		outsettingFormat[6] = AVE_bit * (tmp * 0.04 + 0.3);
	else if(tmp > 10)
		outsettingFormat[6] = AVE_bit * 0.7;
    outsettingFormat[7] = Bitrate_Num;
	/*int i =0;
	printf("\n\n");
	for(i=3;i<8;i++)
		printf("outsettingFormat[%d] = %d ",i,outsettingFormat[i]);
	printf("\n\n");*/
    outsettingFormat[7] = Bitrate_Num;

    outsettingFormat[8] = 0;
    outsettingFormat[9] = Frame_Num *2;
    outsettingFormat[10] =	1;

    unsigned char iwrNum[4] = {0};
    iwrNum[1] = 11;
    target_ext_memory_rd_wt(WRITE,0x80*(hdex%4)+0x10,iwrNum,2);
    write_M23Register(11,outsettingAddress ,outsettingFormat);
	return;
}


/* set program name*/
void setprogname(unsigned char *progName)
{
    unsigned char temdate[4] = {0};
    int len =0;
    int i =0;
    //get progname len
    u8 *tempName = progName;
    while(*tempName++)len++;
    //printf("len:%d",len);
    temdate[0] = 0x60;
    target_ext_memory_rd_wt(WRITE,0x80*(hdex%4)+0x12,temdate,1);

    temdate[0] = len; //progname len
    target_ext_memory_rd_wt(WRITE,0x80*(hdex%4)+0x13,temdate,1);

	target_ext_memory_rd_wt(WRITE,0x80*(hdex%4)+0x60,tempName, len);
	for (i = 0; i < len + 1; i++)
	{
		if (i == len) {
			temdate[0] = '\0';
		}
		else {
			temdate[0] = *(progName + i); //progname len
		}
		target_ext_memory_rd_wt(WRITE, 0x80 * (hdex % 4) + 0x60 + i, temdate, 1);
	}
	return;
}

/* set program number*/
void setProgramNo()
{
    u8 tmp[4] = {0};
    tmp[0] = Program_Num;
    target_ext_memory_rd_wt(WRITE,PROGRAM_START_NO(hdex%4),tmp,1);
	return;
}


/* set pid*/
void setPid()
{
    u8 tmpbuf[8] ={0};
    tmpbuf[0] = PID[0]>>8&0xff;
    tmpbuf[1] = PID[0]&0xff;
    tmpbuf[2] = PID[1]>>8&0xff;
    tmpbuf[3] = PID[1]&0xff;
    tmpbuf[4] = PID[2]>>8&0xff;
    tmpbuf[5] = PID[2]&0xff;
    tmpbuf[6] = PID[3]>>8&0xff;
    tmpbuf[7] = PID[3]&0xff;
	target_ext_memory_rd_wt(WRITE, PID_ADDR((hdex%4)), tmpbuf, 8);
	return;
}

/* audio Source and audio Freq */
void setAudioSourceAndFreq()
{
    u8 tmp[4] = {0};
    tmp[0] = Audio_Freq_Num;
    target_ext_memory_rd_wt(WRITE,GPIOBASE_ADDR + AUDIIO_FREQ_SELECT_OFFSETADDR+(hdex%4)*0x80,tmp,1);
	return;
}



/*...............  readBuffer  ..................*/
void readBuffer()
{
	getMute();
	getoutputformat();
	getinputformat();
	getName();
	getNo();
	getPid();
	getAudioSourceAndFreq();
	getMacAddress();
	return;
}
/* get MUTE */
int getMute()
{
	unsigned char temdate[4] = {0};
	target_ext_memory_rd_wt(READ,0x80*hdex+0x16,temdate,1);
	if( 1 == temdate[0]){
		printf("mute : 1\n");
	}
	else 
	{
		printf("mute : 0\n");
	}
}
/* get outputfmt */
void getoutputformat()
{
    int outsettingFormat[11];
    unsigned char iwrNum[4] = {0};
    target_ext_memory_rd_wt(READ,0x80*(hdex%4)+0x14,iwrNum,1);
    if(iwrNum[0]==1) // auto or not
    {
        printf("Auto mode : Output resolution,code rate and frame rate will be identical to inputs\n");
        return;
    }

    //read_24cxx( 0x15,1, iwrNum);
    target_ext_memory_rd_wt(READ,0x80*(hdex%4)+0x15,iwrNum,1);
    if(iwrNum[0]!=0) // manual or not
    {
        printf("Manual mode : ");
        switch(iwrNum[0])
        {
        case 1:
            printf("super 1920*1080 \n");
            break;
        case 2:
            printf("ultra 1440*1080 \n");
            break;
        case 3:
            printf("excellent 1280*720 \n");
            break;
        case 4:
            printf("good 1120*640 \n");
            break;
        case 5:
            printf("fair 960*540 \n");
            break;
        case 6:
            printf("poor 800*480 \n");
            break;
        case 7:
            printf("mobile 480*272 \n");
            break;
        default:
            break;
        }
        return;
    }

    // read_24cxx( 0x10,2, iwrNum);//advanced mode setting
	int profile;
	int level;
    target_ext_memory_rd_wt(READ,0x80*(hdex%4)+0x10,iwrNum,2);
    if(iwrNum[1]==11)
    {
        read_M23Register(11,outsettingFormat);
		if(outsettingFormat[0] > 512)
		{
			profile=1;
			level = outsettingFormat[0] - 512;

		}
		else
		{
			profile=0;
			level = outsettingFormat[0] - 256;
		}
		float image_change_rate = 0;
		image_change_rate = (float)(outsettingFormat[4] * 100 / outsettingFormat[5]) / 100;
		
		printf("Advanced mode : %d %d %d*%d %.2f %d %d \n",
               profile,level,outsettingFormat[1],outsettingFormat[2],image_change_rate,outsettingFormat[7],outsettingFormat[9]/2);
    }

    return;
}
/* get inputfmt */
void getinputformat()
{
    unsigned short pInputFormat[4];
    unsigned char tmpbuf[8];
    unsigned short VRow, VColumn;
    unsigned short VFreq;
    unsigned short VScan;
    char cScan;
    int i = 0;
    target_ext_memory_rd_wt(READ,ADDRESS_HDMI(hdex%4),tmpbuf,8);
    VColumn = ((tmpbuf[6] << 8)+ tmpbuf[7]);
    VRow    = ((tmpbuf[4] << 8)+ tmpbuf[5]);
    VFreq   = tmpbuf[2];
    VScan   = tmpbuf[1]&1;
    if(VFreq >= 57 && VFreq <= 60)
        VFreq = 60;
    if(VFreq >= 48 && VFreq <= 50)
        VFreq = 50;
    if(VFreq  == 23)
        VFreq = 24;

    pInputFormat[0] = VRow;
    pInputFormat[1] = VColumn;
    pInputFormat[2] = VFreq;
    pInputFormat[3] = VScan;

    if (0 == tmpbuf[0]) {
        printf("input format : No input source\n");
    }else {
        cScan = (pInputFormat[3] == 1)?'I':'P';
        printf("input format : %d*%d%c %dHZ\n",\
               pInputFormat[0],pInputFormat[1],cScan,pInputFormat[2]);
    }

    return;
}
/* get program name*/
int getName()
{
	unsigned char temdate[4] = { 0 };
	int len = 0;
	int i = 0;
	target_ext_memory_rd_wt(READ, 0x80 * (hdex % 4) + 0x12, temdate, 1);
	if (0x60 != temdate[0]) {
		return 0;
	}
	target_ext_memory_rd_wt(READ, 0x80 * (hdex % 4) + 0x13, temdate, 1);
	len = temdate[0];
	char programe[64] = { '0' };

	for (i = 0; i < len; i++)
	{
		target_ext_memory_rd_wt(READ, 0x80 * (hdex % 4) + 0x60 + i, (u8*)&programe[i], 1);
	}
	target_ext_memory_rd_wt(READ, 0x80 * (hdex % 4) + 0x60, (u8*)programe, len);
	printf("programName : %s\n",programe);

	return 0;
}
/* get program number*/
int getNo()
{
	u8 num = 0;
	target_ext_memory_rd_wt(READ, PROGRAM_START_NO(hdex % 4), &num, 1);
    printf("programNumber : %d\n",num);
	return 0;
}
/* get pid*/
int getPid()
{
	int i=0;
	u8 tmpbuf[8];
    u8 eachpid[2];
    for(i = 0; i < 8; i++)
	{
        target_ext_memory_rd_wt(READ,PID_ADDR(hdex%4)+i,&tmpbuf[i],1);
        // printf("tmpbuf[%d] = %d",i,tmpbuf[i]);
    }
	printf("pmt pcr vpid apid : ");
    eachpid[1] = tmpbuf[0];
    eachpid[0] = tmpbuf[1];
    printf("%d ",*(u16*)eachpid);
    eachpid[1] = tmpbuf[2];
    eachpid[0] = tmpbuf[3];
    printf("%d ",*(u16*)eachpid);
    eachpid[1] = tmpbuf[4];
    eachpid[0] = tmpbuf[5];
    printf("%d ",*(u16*)eachpid);
    eachpid[1] = tmpbuf[6];
    eachpid[0] = tmpbuf[7];
    printf("%d\n",*(u16*)eachpid);
}
/* audio Source and audio Freq */
int getAudioSourceAndFreq()
{
	u8 tmpbuf[8];
	memset(tmpbuf,0,6);
	target_ext_memory_rd_wt(READ,
							GPIOBASE_ADDR + AUDIIO_FREQ_SELECT_OFFSETADDR+(hdex%4)*0x80,
							tmpbuf,1);
	if(0 == tmpbuf[0]&0x03)
	{
		printf("audio frequency : 48K\n");//48k
	}
	else if(1 == tmpbuf[0]&0x03)
	{
		printf("audio frequency : 44.1K\n");//44.1k
	}
	else if(2 == tmpbuf[0]&0x03)
	{
		printf("audio frequency : 32K\n");//32k
	}
	else  if(3 == tmpbuf[0]&0x03)
	{
		printf("audio frequency : auto\n");//auto
	}
	else 
	{
		printf("Please set the correct audio frequency(0-3)\n");
	}
}
/* get HDMI MAC */
int getMacAddress()
{
    unsigned char rdbytes[6];
    target_ext_memory_rd_wt(READ,0x80*(hdex%4)+0x08,rdbytes,6);
    printf("mac address : %02x:%02x:%02x:%02x:%02x:%02x\n", \
           rdbytes[0],rdbytes[1],rdbytes[2],rdbytes[3],rdbytes[4],rdbytes[5]);
    return 0;
}


/* ................... load defaults ............. */
void LoadDefaults()
{
	Mute_EN = 1;
    AutoMode = 1;
    Progname_EN = 1;
    Prognumber_EN = 1;
    Pid_EN = 1;
    Audio_Freq_EN = 1;

	Mute_Num = 0;

    unsigned char rdbytes[6];
	char showbuf[64]={0};
    target_ext_memory_rd_wt(READ,0x80*(hdex%4)+0x08,rdbytes,6);
	sprintf(showbuf, "HDMI%02x%02x%02x",rdbytes[3], rdbytes[4], rdbytes[5]);
	int i = 0;	
	while (showbuf[i] != '\0') {
		i++;
	}
	Str_Progname = showbuf;
	//printf("i=%d Str_Progname=%s\n",i,Str_Progname);

	Program_Num = (u8)(hdex + 1);

	u32 Vpid = 260 + 10 * hdex;
	u32 Apid = 261 + 10 * hdex;
	u32 Pmt = 262 + 10 * hdex;
	u32 Pcr = 263 + 10 * hdex;
    PID[0] = Pmt;
    PID[1] = Pcr;
    PID[2] = Vpid;
    PID[3] = Apid;

	Audio_Freq_Num = 3;
	writeBuffer();
	return;
}




/*  Network  */
void Network_read(char* udp_ip, u16 udp_port)
{
    udpMulticastClinet();
	udpfd = udpClose(udpfd);
    sprintf(ipaddr,"%s",udp_ip);
    ipport = udp_port;
    udpfd = udpOpen(ipaddr,ipport);
	
	typeId = 6316;
	u8 a = 0;
	monopolizeCpu_w(0x00, &a, 1);//set 1 主卡释放独占模式
	a = 1;
	monopolizeCpu_w(0x00, &a, 1);//set 1 主卡进入独占模式
	if (1 == Read_Streaming_EN) 
	{
		getStreamingArg();
	}
	else if (1 == Read_IP_Setting_EN) 	
	{
		getLocal_IP_Port();
	}
	a = 0;
	monopolizeCpu_w(0x00, &a, 1);//set 1 主卡释放独占模式

	udpClose(udpfd);
	return;
} 
int setLocal_IP_Port(char* udp_ip, u16 udp_port)
{
	unsigned char Local_parameter[14] = {0};
	udpfd = udpClose(udpfd);
    sprintf(ipaddr,"%s",udp_ip);
    ipport = udp_port;
    udpfd = udpOpen(ipaddr,ipport);

	struct network_inf
	{
		u8 IP_100M[20];
		u16 Port_100M;
		u8 Netmask_100M[20];
		u8 Gateway_100M[20];
		u8 DHCP;
		u8 IP_1G[20];
		u16 Port_1G;
		u8 Netmask_1G[20];
		u8 Gateway_1G[20];
	};
	struct network_inf Network_Inf; 

	FILE* fp = NULL;
	fp = fopen(Network_file,"r");
	if(fp == NULL)
	{
		perror("fopen fail\n");
		exit(1);	
	}
	char str[100] = { 0 };
	u8 *tmp0 = NULL, *tmp1 = NULL;
	char *tmp = NULL,*tmp_str0 = NULL,*tmp_str1 = NULL;
	while(!feof(fp))
	{
		memset(str,0,sizeof(str));
		fgets(str,sizeof(str),fp);
		if( tmp = strstr(str,"\n"))
			*tmp = '\0';
		if( tmp = strstr(str,"\r"))
			*tmp = '\0';


		if(str[0] == '\n' || str[0] == '\r' || str[0] == '\0')
			continue;
		else
		{
			tmp0 = strtok(str, "=");
			tmp1 = strtok(NULL, "=");
			if(tmp0 == NULL || tmp1 == NULL)
			{	
				printf("Please write the configuration file in the correct format\n");
				exit(1);
			}
			tmp_str0 = trim(tmp0);
			tmp_str1 = trim(tmp1);
			if(strcmp("IP_100M",tmp_str0) == 0)
			{
				strcpy(Network_Inf.IP_100M,tmp_str1);
			}
			else if(strcmp("Port_100M",tmp_str0) == 0)
			{
				Network_Inf.Port_100M = atoi(tmp_str1);
			}
			else if(strcmp("Netmask_100M",tmp_str0) == 0)
			{						
				strcpy(Network_Inf.Netmask_100M,tmp_str1);
			}
			else if(strcmp("Gateway_100M",tmp_str0) == 0)
			{
				strcpy(Network_Inf.Gateway_100M,tmp_str1);
			}
			else if(strcmp("DHCP",tmp_str0) == 0)
			{
				Network_Inf.DHCP = atoi(tmp_str1);
			}
			else if(strcmp("IP_1G",tmp_str0) == 0)
			{
				strcpy(Network_Inf.IP_1G,tmp_str1);
			}
			else if(strcmp("Port_1G",tmp_str0) == 0)
			{						
				Network_Inf.Port_1G = atoi(tmp_str1);
			}
			else if(strcmp("Netmask_1G",tmp_str0) == 0)
			{
				strcpy(Network_Inf.Netmask_1G,tmp_str1);
			}
			else if(strcmp("Gateway_1G",tmp_str0) == 0)
			{
				strcpy(Network_Inf.Gateway_1G,tmp_str1);
			}
			else
			{	
				printf("Please write the configuration file in the correct format\n");
				exit(1);
			}
		}
	}
	/*printf("%s\n",Network_Inf.IP_100M);
	printf("%d\n",Network_Inf.Port_100M);
	printf("%s\n",Network_Inf.Netmask_100M);
	printf("%s\n",Network_Inf.Gateway_100M);
	printf("%d\n",Network_Inf.DHCP);
	printf("%s\n",Network_Inf.IP_1G);
	printf("%d\n",Network_Inf.Port_1G);
	printf("%s\n",Network_Inf.Netmask_1G);
	printf("%s\n",Network_Inf.Gateway_1G);
	*/
	typeId = 6316;
	u8 tempbuff_100M[16];
	u8 tempbuff_1G[16];
	memset(tempbuff_100M, 0, 16);
	memset(tempbuff_1G, 0, 16);

	//u8 a = 1;
	//monopolizeCpu_w(0x00, &a, 1);//set 1 主卡进入独占模式

	//100M
	tempbuff_100M[0] = atoi(strtok(Network_Inf.IP_100M, "."));//IP
	tempbuff_100M[1] = atoi(strtok(NULL, "."));
	tempbuff_100M[2] = atoi(strtok(NULL, "."));
	tempbuff_100M[3] = atoi(strtok(NULL, "."));
	tempbuff_100M[4] = (Network_Inf.Port_100M) >> 8 & 0xFF;//Port
	tempbuff_100M[5] = Network_Inf.Port_100M & 0xFF;
	target_ext_memory_rd_wt(WRITE, 0x00 + 0x80, &tempbuff_100M[0], 8);

	tempbuff_100M[8] = atoi(strtok(Network_Inf.Netmask_100M, "."));//Netmask
	tempbuff_100M[9] = atoi(strtok(NULL, "."));
	tempbuff_100M[10] = atoi(strtok(NULL, "."));
	tempbuff_100M[11] = atoi(strtok(NULL, "."));
	tempbuff_100M[12] = atoi(strtok(Network_Inf.Gateway_100M, "."));//Gateway
	tempbuff_100M[13] = atoi(strtok(NULL, "."));
	tempbuff_100M[14] = atoi(strtok(NULL, "."));
	tempbuff_100M[15] = atoi(strtok(NULL, "."));
	target_ext_memory_rd_wt(WRITE, 0x180, &tempbuff_100M[8], 8);

	//1G
	tempbuff_1G[0] = atoi(strtok(Network_Inf.IP_1G, "."));//IP
	tempbuff_1G[1] = atoi(strtok(NULL, "."));
	tempbuff_1G[2] = atoi(strtok(NULL, "."));
	tempbuff_1G[3] = atoi(strtok(NULL, "."));
	tempbuff_1G[4] = (Network_Inf.Port_1G) >> 8 & 0xFF;//Port
	tempbuff_1G[5] = Network_Inf.Port_1G & 0xFF;
	tempbuff_1G[7] = Network_Inf.DHCP;
	target_ext_memory_rd_wt(WRITE, 0x00 + 0x00, &tempbuff_1G[0], 8);

	tempbuff_1G[8] = atoi(strtok(Network_Inf.Netmask_1G, "."));//Netmask
	tempbuff_1G[9] = atoi(strtok(NULL, "."));
	tempbuff_1G[10] = atoi(strtok(NULL, "."));
	tempbuff_1G[11] = atoi(strtok(NULL, "."));
	tempbuff_1G[12] = atoi(strtok(Network_Inf.Gateway_1G, "."));//Gateway
	tempbuff_1G[13] = atoi(strtok(NULL, "."));
	tempbuff_1G[14] = atoi(strtok(NULL, "."));
	tempbuff_1G[15] = atoi(strtok(NULL, "."));
	target_ext_memory_rd_wt(WRITE, 0x100, &tempbuff_1G[8], 8);

	/*int i = 0;
	for(i=0 ; i < 16 ; i++)
	{
		printf("%d  ",tempbuff_100M[i]);
	}
	printf("\n");
	for(i=0 ; i < 16 ; i++)
	{
		printf("%d  ",tempbuff_1G[i]);
	}
	printf("\n");
	*/
	HardRST(); //让修改的IP port Mac生效

	//a = 0;
	//monopolizeCpu_w(0x00, &a, 1);//set 1 主卡释放独占模式

	udpClose(udpfd);
	return 0;
}
int getLocal_IP_Port()
{
	u8 tmpbuf[14] = { 0 };
	u8 g_or_100M = 0;
	u32 t = typeId;
	typeId = 6316;
	udp_REG64_rd(0x4000 + 24, 1, &g_or_100M);//g_or_100M->0:100M g_or_100M->1:1G
	//0. 0x00 ~0x27  100M
	target_ext_memory_rd_wt(READ, 0x00 + 0x80, tmpbuf, 14);

	//1.ip and port
	tmpbuf[6] = tmpbuf[4];
	printf("IP_Port_100M %d.%d.%d.%d:%d\n", tmpbuf[0], tmpbuf[1], tmpbuf[2], tmpbuf[3], *(u16*)&tmpbuf[5]);
	target_ext_memory_rd_wt(READ, 0x180, tmpbuf, 8); //100m
	printf("Netmask_100M %d.%d.%d.%d\n", tmpbuf[0], tmpbuf[1], tmpbuf[2], tmpbuf[3]);
	printf("Gateway_100M %d.%d.%d.%d\n", tmpbuf[4], tmpbuf[5], tmpbuf[6], tmpbuf[7]);
	memset(tmpbuf, 0, 14);

	//0. 0x00 ~0x27 1g
	target_ext_memory_rd_wt(READ, 0x00, tmpbuf, 14);
	//1.ip and port
	if (1 == (tmpbuf[7] & (0x01)))//auto
		printf("DHCP 1\n");
	else if (0 == (tmpbuf[7] & (0x01))) //manal
		printf("DHCP 0\n");

	tmpbuf[6] = tmpbuf[4];
	printf("IP_Port_1G %d.%d.%d.%d:%d\n", tmpbuf[0], tmpbuf[1], tmpbuf[2], tmpbuf[3], *(u16*)&tmpbuf[5]);
	target_ext_memory_rd_wt(READ, 0x100, tmpbuf, 8); //1g
	printf("Netmask_1G %d.%d.%d.%d\n", tmpbuf[0], tmpbuf[1], tmpbuf[2], tmpbuf[3]);
	printf("Gateway_1G %d.%d.%d.%d\n", tmpbuf[4], tmpbuf[5], tmpbuf[6], tmpbuf[7]);
	memset(tmpbuf, 0, 14);
	typeId = t;
	return 0;
}

/* 1，0地址变化触发使修改IP PORT MAC生效 */
void HardRST()
{
    typeId = 6316;
    u8 tmpbuf[4] = { 0xff,0xff,0xff,0xff };
    REG64_wt(0x4014, 4, tmpbuf);
    usleep(2000);
    tmpbuf[0] = 0x00;
    REG64_wt(0x4014, 4, tmpbuf);
    typeId = 63081;
}

int getStreamingArg()
{
	u8 tmpflg0 = 1,tmpflg1 = 1;
	u8 tmpbuf[15] = {0};
	u8 tmpstatus[3] = {0};
	u16 port = 0 ,streamStatus = 0;
	typeId = 6316;

	u32 NullPackedAddr = 0x50;
	u8 NullPacked = 0;

	int i,j;
	REG64_rd(0x4000 + 7 * 4, 2, &tmpstatus[1]);
	tmpstatus[0] = tmpstatus[2];
	/*for (int i = 0; i < 2; i++) {
		printf("tmpstatus[%d] = %#02x\n", i, tmpstatus[i]);
	}*/

	for(i = 0; i <= Net_Infor_numbor; i++)
	{

		tmpflg0 = strcmp(ipaddr,Net_Infor[i].ip_100M);
		tmpflg1 = strcmp(ipaddr,Net_Infor[i].ip_1000M);
		//printf("\n\n%s %d %d\n\n",ipaddr,tmpflg0,tmpflg1);
		if((tmpflg0 == 0 || tmpflg1 == 0) && Net_Infor[i].validCaptureNum != 0)
		{						
			printf("\nCapture\tUnicastIP/MulticastIP\tPort\tNullPacked\tNetProtocol\tEnable/Disanble\tStreamingStatus\n");
			for (j = 0; j < 16; j++) 
			{
				if(Net_Infor[i].Item_tuner[j] == -1)
					continue;
				else
				{

					memset(tmpbuf, 0, 15);
					if (0 <= j && j <= 3)
						NullPackedAddr = 0x50 + (j % 4);
					else if (4 <= j && j <= 7)
						NullPackedAddr = 0xD0 + (j % 4);
					else if (8 <= j && j <= 11)
						NullPackedAddr = 0x150 + (j % 4);
					else if (12 <= j && j <= 15)
						NullPackedAddr = 0x1D0 + (j % 4);
					target_ext_memory_rd_wt(READ, NullPackedAddr, &NullPacked, 1);
					NullPacked = NullPacked & 0x01;

					memset(tmpbuf, 0, 15);
        			target_ext_memory_rd_wt(READ, NET_BASE_ADDR_CHILD(j/4)+ OFFICE_CHILD_HDMI(j%4), tmpbuf, 14);
					printf("%d\t",Net_Infor[i].Item_tuner[j]);
        			printf("%d.%d.%d.%d\t\t",tmpbuf[2],tmpbuf[3], tmpbuf[4], tmpbuf[5]);

        			tmpbuf[14] = tmpbuf[12];
        			port = *(u16*)&tmpbuf[13];
        			printf("%d\t",port);

					if(0 == NullPacked)
						printf("Never\t\t");
					else if(1 == NullPacked)
						printf("Always\t\t");
	
        			if(0 == (tmpbuf[1]&0x01))
					{
			            printf("UDP\t\t");
        			}
					else if(1 == (tmpbuf[1]&0x01))	
					{
            			printf("RTP\t\t");
        			}

        			if(0 == (tmpbuf[0]&0x01))
					{
            			printf("Disanble\t");
        			}
					else if(1 == (tmpbuf[0]&0x01))
					{
            			printf("Enable\t");
        			}

					streamStatus = ((*(u16*)&tmpstatus[0]) >> j) & 0x01;
					if(streamStatus == 0)
						printf("Light on");
					else if(streamStatus == 1)
						printf("Light off");
					//printf("%d",streamStatus);//0:灯亮 1:灯灭
					printf("\n");
				}
			}
		}
	}
	printf("\n");
	return 0;
}

char *trim(char* str)
{
	if (str == NULL || *str == '\0')
	{
		return str;
	}
	char *start = str;

	int i=0;
	while (isspace(*start) && *start)
	{
		++start;
		++i;
	}
	int len = strlen(str);
	char *end = str + len -1;

	while (*end && isspace(*end)){
		*end = '\0';
		--end;
	}
	memmove(str, start, strlen(str) - i + 1);
	return str;
}

int setStreamingArg(char* udp_ip, u16 udp_port)
{
    udpMulticastClinet();
	udpfd = udpClose(udpfd);
    sprintf(ipaddr,"%s",udp_ip);
    ipport = udp_port;
    udpfd = udpOpen(ipaddr,ipport);

	u8 i=0;
	u8 streamingbuf[16];
	u32 t = 0;
	typeId = 6316;

	u8 a = 0;
	monopolizeCpu_w(0x00, &a, 1);//set 1 主卡释放独占模式
	a = 1;
	monopolizeCpu_w(0x00, &a, 1);//set 1 主卡进入独占模式

	u8 *tmp0 = NULL, *tmp1 = NULL;

	char str[100];
	struct capture_select_inf
	{
		char Capture_Num;
		char IP[20];
		int Port;
		char Null_Packed;
		char Net_Protocol; //0:udp 1:rtp
		char Enable_Disanble;//0:disanble 1:enable
	};
	struct capture_select_inf capture_select[16];

	FILE* fp = NULL;
	fp = fopen(Streaming_file,"r");
	if(fp == NULL)
	{
		perror("fopen fail\n");
		exit(1);	
	}

	int tmp_flg=0;
	char *tmp = NULL,*tmp_str0 = NULL,*tmp_str1 = NULL;
	while(!feof(fp))
	{
		memset(str,0,sizeof(str));
		fgets(str,sizeof(str),fp);
		if( tmp = strstr(str,"\n"))
			*tmp = '\0';
		if( tmp = strstr(str,"\r"))
			*tmp = '\0';
		if(strcmp("[capture]",str) == 0)
		{
			tmp_flg++;
		}
		else
		{
			if(str[0] == '\n' || str[0] == '\r' || str[0] == '\0')
				continue;
			else
			{
				tmp0 = strtok(str, "=");
				tmp1 = strtok(NULL, "=");
				if(tmp0 == NULL || tmp1 == NULL)
				{	
					printf("Please write the configuration file in the correct format\n");
					exit(1);
				}
				tmp_str0 = trim(tmp0);
				tmp_str1 = trim(tmp1);
				if(strcmp("Capture_Num",tmp_str0) == 0)
				{
					capture_select[tmp_flg-1].Capture_Num = atoi(tmp_str1);
				}
				else if(strcmp("IP",tmp_str0) == 0)
				{
					strcpy(capture_select[tmp_flg-1].IP, tmp_str1);
				}
				else if(strcmp("Port",tmp_str0) == 0)
				{						
					capture_select[tmp_flg-1].Port = atoi(tmp_str1);
				}
				else if(strcmp("Null_Packed",tmp_str0) == 0)
				{						
					capture_select[tmp_flg-1].Null_Packed = atoi(tmp_str1);
				}
				else if(strcmp("Net_Protocol",tmp_str0) == 0)
				{
					capture_select[tmp_flg-1].Net_Protocol = atoi(tmp_str1);
				}
				else if(strcmp("Enable_Disanble",tmp_str0) == 0)
				{
					capture_select[tmp_flg-1].Enable_Disanble = atoi(tmp_str1);
				}
				else
				{	
					printf("Please write the configuration file in the correct format\n");
					exit(1);
				}
			}
		}
	}
	/*printf("\n\n tmp_flg=%d \n\n",tmp_flg);
	for(i=0 ; i<tmp_flg ; i++)
	{
		printf("%d %s %d %d %d \n",capture_select[i].Capture_Num,
				capture_select[i].IP,capture_select[i].Port,
				capture_select[i].Net_Protocol,capture_select[i].Enable_Disanble);
	}*/

	char tem_IP[4] = {0};
	char tmp_index=0;
	u32 NullPackedAddr = 0x50;
	u8 NullPacked = 1;
	for (i = 0; i < tmp_flg; i++) 
	{
		streamingbuf[0] = capture_select[i].Enable_Disanble;//Close or Open
		streamingbuf[1] = capture_select[i].Net_Protocol;//UDP or RTP
		streamingbuf[2] = atoi(strtok(capture_select[i].IP,"."));//IP
		streamingbuf[3] = atoi(strtok(NULL,"."));
		streamingbuf[4] = atoi(strtok(NULL,"."));
		streamingbuf[5] = atoi(strtok(NULL,"."));

		streamingbuf[12] = (capture_select[i].Port >> 8) & 0x0ff;//PORT
		streamingbuf[13] = capture_select[i].Port & 0x0ff;

		tmp_index = capture_select[i].Capture_Num;//capture
		target_ext_memory_rd_wt(WRITE, NET_BASE_ADDR_CHILD(tmp_index / 4) + OFFICE_CHILD_HDMI(tmp_index % 4), streamingbuf, 6);
		target_ext_memory_rd_wt(WRITE, NET_BASE_ADDR_CHILD(tmp_index / 4) + OFFICE_CHILD_HDMI(tmp_index % 4) + 0x0c, &streamingbuf[12], 2);


		NullPacked = capture_select[i].Null_Packed;
		if (0 <= tmp_index && tmp_index <= 3)
			NullPackedAddr = 0x50 + (tmp_index % 4);
		else if (4 <= tmp_index && tmp_index <= 7)
			NullPackedAddr = 0xD0 + (tmp_index % 4);
		else if (8 <= tmp_index && tmp_index <= 11)
			NullPackedAddr = 0x150 + (tmp_index % 4);
		else if (12 <= tmp_index && tmp_index <= 15)
			NullPackedAddr = 0x1D0 + (tmp_index % 4);

		target_ext_memory_rd_wt(WRITE, NullPackedAddr, &NullPacked, 1);

		typeId = 6316;
		target_ext_memory_rd_wt(WRITE, 0xff08, (u8*)&tmp_index, 1);//使set生效
	}
	getStreamingArg();

	a = 0;
	monopolizeCpu_w(0x00, &a, 1);//set 1 主卡进入独占模式
	fclose(fp);
	udpClose(udpfd);
	//得到ip port udp close
	return 0;
}


void refresh_status(char* udp_ip, u16 udp_port)
{
	if(udp_ip == NULL)
	{
		printf("Please enter the IP of FPJA\n");
		exit(1);	
	}
	else
	{
        sprintf(ipaddr,"%s",udp_ip);
        ipport = udp_port;
        udpfd = udpOpen(ipaddr,ipport);

		int i=0;
		u8 tmpstatus[3] = {0};
		u16 streamStatus = 0;
		typeId = 6316;
		REG64_rd(0x4000 + 7 * 4, 2, &tmpstatus[1]);
		tmpstatus[0] = tmpstatus[2];
		/*for (int i = 0; i < 2; i++) {
			printf("tmpstatus[%d] = %#02x\n", i, tmpstatus[i]);
		}*/

		for (i = 0; i < 16; i++) 
		{
			streamStatus = ((*(u16*)&tmpstatus[0]) >> i) & 0x01;
			printf("%d ",streamStatus);//0:灯亮 1:灯灭
		}
		printf("\n");
    }
	return;
} 



//restart
int restartDevice(char * ipaddr,int ipport)
{

    int n = 0;
    int i = 0;
    int j = 0;
    int ufd = -1;
    char sendbuff[64] = {0};
    char recvbuff[64] = {0};
    struct timeval timeout = {1,0};

    /*create Socket*/
    if ((ufd = socket(AF_INET, SOCK_DGRAM, 0)) == -1) {
        printf( "fail to socket\n");
        return 0;
    }
    /*set sockaddr_in*/
    memset(&udpsockaddr, 0, sizeof(udpsockaddr));
    udpsockaddr.sin_family = AF_INET;
    udpsockaddr.sin_port = htons(ipport);
    udpsockaddr.sin_addr.s_addr = inet_addr(ipaddr);
    socklen_t len  = sizeof(udpsockaddr);
    setsockopt(ufd, SOL_SOCKET, SO_RCVTIMEO, (char *)&timeout, sizeof(struct timeval));
    setsockopt(ufd, SOL_SOCKET, SO_SNDTIMEO, (char *)&timeout, sizeof(struct timeval));


	sendbuff[0] = 0x00;//read
	sendbuff[1] = 0x00;
	sendbuff[2] = 0x40;
	sendbuff[3] = 0xff;
	sendbuff[4] = 0x54;
	sendbuff[5] = 0x42;
	sendbuff[6] = 0x53;
	sendbuff[7] = 0x5f;
	sendbuff[8] = 0x52;
	sendbuff[9] = 0x53;
	sendbuff[10] = 0x54;
	sendbuff[11] = 0x4e;


    n = sendto(ufd, sendbuff, 64, 0, (struct sockaddr*)&udpsockaddr, len);
    if (n < 0) {
        printf("udp_REG64_wt:sendto time out\n");
        return ;
    }

    memset(recvbuff, 0, 64);
    n = recvfrom(ufd, recvbuff, 64, 0, (struct sockaddr*)&udpsockaddr, &len);
    if (n < 0) {
        printf("udp_REG64_wt:recvfrom time out\n");
        return ;
    }

    /*for ( i = 0; i < 64; i++) {
        printf("%02x ", (u8)recvbuff[i]);
    }*/
	if(	(recvbuff[0] & 0xFF) == 0x00 && (recvbuff[1] & 0xFF) == 0x88 &&
		(recvbuff[2] & 0xFF) == 0x40 && (recvbuff[3] & 0xFF) == 0xff &&
		(recvbuff[4] & 0xFF) == 0x54 && (recvbuff[5] & 0xFF) == 0x42 &&
		(recvbuff[6] & 0xFF) == 0x53 && (recvbuff[7] & 0xFF) == 0x5f &&
		(recvbuff[8] & 0xFF) == 0x52 && (recvbuff[9] & 0xFF) == 0x53 &&
		(recvbuff[10] & 0xFF) == 0x54 && (recvbuff[11] & 0xFF) == 0x4e)
	{
		printf("Reset successfully\n");
	}
	else
	{
		printf("Reset failed\n");
	}

	close(ufd);

    return 0;
}

int resetChannel(char *ipaddr,int port,u8 channel)
{
	if(channel < 0 || channel > 15)
	{
		printf("\n\nPlease select a valid channel(0-15)\n\n");
		return 0;
	}
    typeId = 63081;
    udpfd = udpOpen(ipaddr,port);
	u8 tmpbuf[4] = { 0 };
	u8 hdex = channel;
	//printf("\n\nhdex = %d\n\n",hdex);
	target_ext_memory_rd_wt(WRITE, ADDRESS_HDMI(hdex%4) + 0x08, tmpbuf, 1);
	printf("Reset channel successful\n");
	udpClose(udpfd);
	return 0;
}

int resetCaptureCard(char *ipaddr,int port,u8 capture_card)
{
	if(capture_card < 0 || capture_card > 3)
	{
		printf("\n\nPlease enter a valid capture card(0-3)\n\n");
		return 0;
	}
	typeId = 6316;
	udpfd = udpOpen(ipaddr,port);
	target_ext_memory_rd_wt(WRITE, 0xff09, (u8*)&capture_card, 1);//使set生效
	printf("Reset capture card successfully\n");
	udpClose(udpfd);
	return 0;
}



/* ...... 释放独占模式 ...... */
void monopolizeCpu_close()
{
	u8 a = 0;
	typeId = 6316;
	monopolizeCpu_w(0x00, &a, 1);//set 0 释放子卡独占模式
	typeId = 63081;
	monopolizeCpu_w(0x00, &a, 1);//set 0 释放主卡独占模式
	return;
}
/* ...... 进入独占模式 ...... */
void monopolizeCpu_open()
{
	u8 a = 1;
	typeId = 6316;
	monopolizeCpu_w(0x00, &a, 1);//set 1 主卡进入独占模式
	typeId = 63081;
	monopolizeCpu_w(0x00, &a, 1);//set 1 子卡进入独占模式
	return;
}
u8 monopolizeCpu_r_REG32(int m_addr, unsigned char *rdbuff, unsigned char num)
{
	unsigned char i, buff[8];

	if (num == 0)
	{
		printf(" rd error! (num == 0) ");
		return 0;

	}
	else if (num > 8)
	{
		printf(" rd error! (num >8) ");
		return 0;

	}

	//...check host free -->......................
	if (Check_host_status(1) == 0)
	{
		printf(" wait for host free timeout!");
		return 0;
	}

	//...wt data & cs to low-->...................
	buff[0] = 0x33;
	buff[1] = num;
	buff[2] = (unsigned char)(m_addr >> 8);
	buff[3] = (unsigned char)(m_addr & 255);
	REG64_wt(0x4000 + 0 * 4, 4, buff);  //cs low;

										//...ck host received data & process-->........
	if (Check_host_status(0) == 0)
	{
		printf(" wait for host active timeout! ");
		//return 0;
	}

	//...cs high................................

	REG64_wt(0x4000 + 3 * 4, 4, buff);  //cs high;
	//...check host work done-->..................
	if (wait_for_host_workdone() == 0)
	{
		printf(" wait host work done timeout! ");
		return 0;
	}

	REG64_rd(0x4000 + 1 * 4, 4, &buff[0]);
	REG64_rd(0x4000 + 2 * 4, 4, &buff[4]);
	for (i = 0; i < num; i++)
		rdbuff[i] = buff[i];
	return 1;
}
u8 monopolizeCpu_w_REG32(int m_addr, unsigned char *wtbuff, unsigned char num)
{
	unsigned char i = 0;
	unsigned char buff[8] = { 0 };

	if (num == 0)
	{
		printf(" wt error! (num == 0)  \n");
		return 0;

	}
	else if (num > 8)
	{
		printf(" wt error! (num >8) ");
		return 0;

	}
	//...check host free -->......................
	if (Check_host_status(1) == 0)
	{
		printf(" wait for host free timeout!");
		return 0;
	}
	//...wt data & cs to low-->...................
	for (i = 0; i < num; i++)
		buff[i] = wtbuff[i];
	REG64_wt(0x4000 + 2 * 4, 4, &buff[4]);
	REG64_wt(0x4000 + 1 * 4, 4, &buff[0]);

	buff[0] = 0x32;
	buff[1] = num;
	buff[2] = (unsigned char)(m_addr >> 8);
	buff[3] = (unsigned char)(m_addr & 255);
	REG64_wt(0x4000 + 0 * 4, 4, buff);  //cs low;

										//...ck host received data & process-->........
	if (Check_host_status(0) == 0)
	{
		printf(" wait for host active timeout! ");
		//return 0;
	}

	//...cs high................................

	REG64_wt(0x4000 + 3 * 4, 4, buff);  //cs high;

										//...check host work done-->..................
	if (wait_for_host_workdone() == 0)
	{
		printf(" wait host work done timeout! ");
		return 0;
	}
	return 1;
}
u8 monopolizeCpu_w(int m_addr, unsigned char * wtbuff, unsigned char num)
{
	switch (typeId) {
	case 63081:
	case 6316:
		return monopolizeCpu_w_REG32(m_addr, wtbuff, num);
		break;
	default:
		break;
	}
	return 1;
}
u8 monopolizeCpu_r(int m_addr, unsigned char * rdbuff, unsigned char num)
{
	switch (typeId) {
	case 63081:
	case 6316:
		return monopolizeCpu_r_REG32(m_addr, rdbuff, num);
		break;
	default:
		break;
	}
	return 1;
}


