#include <stdbool.h>
#include <unistd.h>
#include <stdlib.h>
#include <stdio.h>
#include <unistd.h>
#include <stdint.h>
#include <inttypes.h>
#include <stdbool.h>
#include <string.h>
#include <ctype.h>
#include <pthread.h>
#include <netdb.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <signal.h>
#include <getopt.h>
#include <errno.h>
#include <fcntl.h>  
#include <string.h>  
#include <sys/types.h>  
#include <sys/stat.h>  
#include <linux/fs.h>

#define QMSLEEP(n)   usleep(1000*(n))
#ifndef WRITE
#define WRITE            0
#endif
#ifndef READ
#define READ             1
#endif
#define SPI_CONFIG      	 0x10
#define SPI_STATUS      	 0x10
#define SPI_COMMAND     	 0x14
#define SPI_WT_DATA     	 0x18
#define SPI_RD_DATA     	 0x1c
#define SPI_ENABLE       	 0x1c
#define GPIO_VERSION         0x20

//HDMI the folloing address( Write:User input video format, Read: true format from 6604)   very import: High and low is reversed

#define HDMI_RST  		0x44      //system reset
#define HDMI_AUTO_MODE  0x48  	  //Auto_mode (1) meaningful. System to identify video format parameters or user input video format parameters
#define HDMI_HYNC_VYNC  0x48      //bit[31:16]Hync, bit[15:0]Vync
#define HDMI_SCAN_FREQ	0x4c      //bit[31:24] Video format frequency parameters, Bit[16]: user input video format is  (0:interleave): 1:progressive) scanning
//===============================================

//-------------24cXX --------------------------------------------------------
#define BASE_ADDRESS_24CXX  	0x4000
#define CMD_24CXX	      0*4   //write only
#define DATA0_24CXX       1*4   //W/R
#define DATA1_24CXX       2*4   //W/R
#define CS_RELEASE        3*4   //write only

#define STATUS_MAC16_24CXX	 0*4   //read only
#define MAC32_24CXX	 		 3*4   //read only
//---------------------------------------------------------------------
/*********************tbs6304*******************************/
#define  ADDRESS_HDMI(n)  (0xff00+(n)*0x40)
#define  ADDRESS_HDMI0    0xff00
#define  ADDRESS_HDMI1    0xff40
#define  ADDRESS_HDMI2    0xff80
#define  ADDRESS_HDMI3    0xffc0

#define GPIOBASE_ADDR     0x0000
#define CHIP_OFFSET_ADDR  4*8

#define  PID_ADDR(n)           (0x70+(n)*0x80)
#define  PMT_MSB          0x70
#define  PMT_LSB          0x71
#define  PCR_MSB          0x72
#define  PCR_LSB          0x73
#define  VPID_MSB         0x74
#define  VPID_LSB         0x75
#define  APID_MSB         0x76
#define  APID_LSB         0x77
#define  PROGRAM_START_NO(n) (0x0f+0x80*(n))


// HardRST
#define  BASE_ADDRESS_HARDRST     0x0000
#define OFFSET_ADDRESS_HARDRST    1*4

//mac
#define  MAC_ADDRESS_2           0*4
#define  MAC_ADDRESS_4           3*4

#define MAP_FPGA_BASEADDR       0x4000//write
#define WRITE_CMD                       0*8
#define WRITE_DATA                      1*8
#define RELEASE_CS                      2*8
//read
#define HOST_STATUS           0*8
//// {5'd0,mcu_busy,write_error,mcu_done,56'd0};
#define READ_DATA                     1*8
#define READ_MAC                      2*8

#define AUDIIO_SELECT_OFFSETADDR        0x17     //bit[56]
#define AUDIIO_FREQ_SELECT_OFFSETADDR   0x18     //bit[48:49]

#define  BASE_SETTING_NET_ADDR			0x0100
#define  NET_LOCAL_MAC_OFFSETADDR		0x00   //0x00 ~ 0x05
#define  NET_LOCAL_IP_OFFSETADDR        0x08   //0x08~0x0b
#define  NET_SERVER_PORT_OFFSETADDR     0x0c   //0x0c~0x0d
#define  SELECT_UDP_OR_RTP_OFFSETADDR   0x0e
//0x10~0x27:	one RTP parameter(Total 24 bytes)
#define  RTP_PARAMETER_OFFSETADDR       0x10
/*
   rtp_gate;  		//bit 7;
   all_ts_through;  	//bit6
   position;			//bit5~3
   ts_port;			//bit2~0
   */
#define  RTP_PID_EN_OFFSETADDR	        0x11
#define  UDP_PORT_OFFSETADDR	        0x12   //2 bytes
#define  RTP_IP_ADDR_OFFSETADDR	        0x14   //4 bytes
#define  RTP_TV_PID_OFFSETADDR	        0x18   //16 bytes

#define  I2C_CHIP_ADDRESS               0x50
#define  BUS_IS_FREE_OFFSETADDR         0x02
#define  CHECK_I2C_BUS_ADDR             0x11
#define  RE_RUN_NETWORK_ADDR            0xfe00

//6316
#define NET100M_CMD   0 * 4
#define NET100M_DT32  1 * 4
#define NET100M_ACK   0 * 4
#define NET100M_RDDT  1 * 4
#define NET_100M_ADDR(n) (0x1000 + 0x400*(n))

#define NET_BASE_ADDR_CHILD(n)     (0x0000 +0x80*(n))
#define OFFICE_CHILD_HDMI(n)       (0x10*(n+1))



typedef unsigned char u8;
typedef unsigned short u16;
typedef unsigned int u32; 

extern u32 typeId;
extern int udpfd;
extern struct sockaddr_in udpsockaddr;

typedef struct ne{
		//u8 device_num;
		u8 mac[30];
		u8 name[20];
        u8 ip_100M[20];
        u8 ip_1000M[20];
        u16 port_100M; 
        u16 port_1000M;
		signed char Item_tuner[16];
		u16	validCaptureNum;

} netinfor;

extern int hdex;

void read_M23Register( int num, int* m23_data);
void write_M23Register( int num, int* m23_addr, int* m23_data);

void REG64_rd(int subAddr, unsigned char num, unsigned char *rdbuffer);
void REG64_wt(int subAddr, unsigned char num, unsigned char *wtbuffer);

unsigned char read_from_external_memory(int addr, unsigned char num, unsigned char *buff);
unsigned char write_to_external_memory(int addr, unsigned char num, unsigned char *buff);
unsigned char check_host_free_REG64();
unsigned char Check_host_status_REG64(unsigned char status);

bool Check_host_status(unsigned char cs);  //2 seconds timeout;
bool wait_for_host_workdone();  //3 seconds timeout;

bool ext_one_time_wt(int m_addr,unsigned char *wtbuff,unsigned char num);
bool ext_one_time_wt_REG32(int m_addr,unsigned char *wtbuff,unsigned char num);
bool ext_ram_write(int ram_addr,unsigned char *wtbff,int wt_size);
bool ext_one_time_rd(int m_addr,unsigned char *rdbuff,unsigned char num);
bool ext_one_time_rd_REG32(int m_addr,unsigned char *rdbuff,unsigned char num);
bool ext_ram_read(int ram_addr,unsigned char *rdbff,int rd_size);
bool target_ext_memory_rd_wt(unsigned char tg_mode,int tg_addr,unsigned char *buff,int tg_size);

//net
int udpOpen(char * ipaddr,int ipport);
int udpClose(int ufd);
int testUdpNet();

/*********udp*************/
int udp_checkI2cBusStatus();
void HardRST();
//net
void udp_REG64_rd(int subAddr, unsigned char num, unsigned char *rdbuffer);
void udp_REG64_wt(int subAddr, unsigned char num, unsigned char *wtbuffer);

void udp_REG64_rd_child(int subAddr,unsigned char num,unsigned char *rdbuffer);
void udp_REG64_wt_child(int subAddr,unsigned char num,unsigned char *wtbuffer);

void selectIp(char* udp_ip, u16 udp_port, u16 capture_X);
int getswitchstatus(u8* ip, u16 port,netinfor* Net_Infor);
void showNetTuners(char *ipport);
void printf_card_inf();
void udpMulticastClinet();

void LoadDefaults();
int reHdmi();
void setMute();
void autoMode();
void manualMoe();
void advancedMode();
void setprogname(unsigned char *progName);
void setProgramNo();
void setPid();
void setAudioSourceAndFreq();
void writeBuffer();

void getinputformat();
int getMacAddress();
int getMute();
void getoutputformat();
int getName();
int getNo();
int getPid();
int getAudioSourceAndFreq();
void readBuffer();


char *trim(char* str);
int getStreamingArg();
int getLocal_IP_Port();
void Network_read(char* udp_ip, u16 udp_port);
int setStreamingArg(char* udp_ip, u16 udp_port);
int setLocal_IP_Port(char* udp_ip, u16 udp_port);

void refresh_status(char* udp_ip, u16 udp_port);
int restartDevice(char * ipaddr,int ipport);
int resetChannel(char *ipadd,int port,u8 channel);
int resetCaptureCard(char *ipadd,int port,u8 capture_card);



void monopolizeCpu_close();
void monopolizeCpu_open();
u8 monopolizeCpu_r_REG32(int m_addr, unsigned char *rdbuff, unsigned char num);
u8 monopolizeCpu_w_REG32(int m_addr, unsigned char *wtbuff, unsigned char num);
u8 monopolizeCpu_w(int m_addr, unsigned char * wtbuff, unsigned char num);
u8 monopolizeCpu_r(int m_addr, unsigned char * rdbuff, unsigned char num);

